--- /homez.786/ridinteadu/_serious_analysis/van_21.0.0/dolibarr-21.0.0/htdocs/public/stripe/ipn.php	2025-03-03 15:58:17.000000000 +0000
+++ /homez.786/ridinteadu/seriousbeta/dolibarr/htdocs/public/stripe/ipn.php	2025-05-06 09:38:45.569450000 +0000
@@ -44,18 +44,18 @@
 
 // Load Dolibarr environment
 require '../../main.inc.php';
-require_once DOL_DOCUMENT_ROOT.'/core/lib/admin.lib.php';
-require_once DOL_DOCUMENT_ROOT.'/user/class/user.class.php';
-require_once DOL_DOCUMENT_ROOT.'/core/class/ccountry.class.php';
-require_once DOL_DOCUMENT_ROOT.'/commande/class/commande.class.php';
-require_once DOL_DOCUMENT_ROOT.'/compta/paiement/class/paiement.class.php';
-require_once DOL_DOCUMENT_ROOT.'/compta/facture/class/facture.class.php';
-require_once DOL_DOCUMENT_ROOT.'/compta/bank/class/account.class.php';
-require_once DOL_DOCUMENT_ROOT.'/compta/prelevement/class/bonprelevement.class.php';
-require_once DOL_DOCUMENT_ROOT.'/societe/class/societe.class.php';
-require_once DOL_DOCUMENT_ROOT.'/core/class/CMailFile.class.php';
-require_once DOL_DOCUMENT_ROOT.'/includes/stripe/stripe-php/init.php';
-require_once DOL_DOCUMENT_ROOT.'/stripe/class/stripe.class.php';
+require_once DOL_DOCUMENT_ROOT . '/core/lib/admin.lib.php';
+require_once DOL_DOCUMENT_ROOT . '/user/class/user.class.php';
+require_once DOL_DOCUMENT_ROOT . '/core/class/ccountry.class.php';
+require_once DOL_DOCUMENT_ROOT . '/commande/class/commande.class.php';
+require_once DOL_DOCUMENT_ROOT . '/compta/paiement/class/paiement.class.php';
+require_once DOL_DOCUMENT_ROOT . '/compta/facture/class/facture.class.php';
+require_once DOL_DOCUMENT_ROOT . '/compta/bank/class/account.class.php';
+require_once DOL_DOCUMENT_ROOT . '/compta/prelevement/class/bonprelevement.class.php';
+require_once DOL_DOCUMENT_ROOT . '/societe/class/societe.class.php';
+require_once DOL_DOCUMENT_ROOT . '/core/class/CMailFile.class.php';
+require_once DOL_DOCUMENT_ROOT . '/includes/stripe/stripe-php/init.php';
+require_once DOL_DOCUMENT_ROOT . '/stripe/class/stripe.class.php';
 /**
  * @var Conf $conf
  * @var DoliDB $db
@@ -63,82 +63,147 @@
  */
 
 // You can find your endpoint's secret in your webhook settings
-if (GETPOSTISSET('connect')) {
-	if (GETPOSTISSET('test')) {
-		$endpoint_secret = getDolGlobalString('STRIPE_TEST_WEBHOOK_CONNECT_KEY');
-		$service = 'StripeTest';
-		$servicestatus = 0;
-	} else {
-		$endpoint_secret = getDolGlobalString('STRIPE_LIVE_WEBHOOK_CONNECT_KEY');
-		$service = 'StripeLive';
-		$servicestatus = 1;
-	}
-} else {
-	if (GETPOSTISSET('test')) {
-		$endpoint_secret = getDolGlobalString('STRIPE_TEST_WEBHOOK_KEY');
-		$service = 'StripeTest';
-		$servicestatus = 0;
-	} else {
-		$endpoint_secret = getDolGlobalString('STRIPE_LIVE_WEBHOOK_KEY');
-		$service = 'StripeLive';
-		$servicestatus = 1;
+// if (GETPOSTISSET('connect')) {
+// 	if (GETPOSTISSET('test')) {
+// 		$endpoint_secret = getDolGlobalString('STRIPE_TEST_WEBHOOK_CONNECT_KEY');
+// 		$service = 'StripeTest';
+// 		$servicestatus = 0;
+// 	} else {
+// 		$endpoint_secret = getDolGlobalString('STRIPE_LIVE_WEBHOOK_CONNECT_KEY');
+// 		$service = 'StripeLive';
+// 		$servicestatus = 1;
+// 	}
+// } else {
+// 	if (GETPOSTISSET('test')) {
+// 		$endpoint_secret = getDolGlobalString('STRIPE_TEST_WEBHOOK_KEY');
+// 		$service = 'StripeTest';
+// 		$servicestatus = 0;
+// 	} else {
+// 		$endpoint_secret = getDolGlobalString('STRIPE_LIVE_WEBHOOK_KEY');
+// 		$service = 'StripeLive';
+// 		$servicestatus = 1;
+// 	}
+// }
+
+// if (!isModEnabled('stripe')) {
+// 	httponly_accessforbidden('Module Stripe not enabled');
+// }
+
+// if (empty($endpoint_secret)) {
+// 	httponly_accessforbidden('Error: Setup of module Stripe not complete for mode '.dol_escape_htmltag($service).'. The WEBHOOK_KEY is not defined.', 400, 1);
+// }
+
+// if (getDolGlobalString('STRIPE_USER_ACCOUNT_FOR_ACTIONS')) {
+// 	// We set the user to use for all ipn actions in Dolibarr
+// 	$user = new User($db);
+// 	$user->fetch(getDolGlobalString('STRIPE_USER_ACCOUNT_FOR_ACTIONS'));
+// 	$user->loadRights();
+// } else {
+// 	httponly_accessforbidden('Error: Setup of module Stripe not complete for mode '.dol_escape_htmltag($service).'. The STRIPE_USER_ACCOUNT_FOR_ACTIONS is not defined.', 400, 1);
+// }
+
+// $now = dol_now();
+
+// // Security
+// // The test on security key is done later into constructEvent() method.
+
+
+// /*
+//  * Actions
+//  */
+
+// $payload = @file_get_contents("php://input");
+// $sig_header = empty($_SERVER["HTTP_STRIPE_SIGNATURE"]) ? '' : $_SERVER["HTTP_STRIPE_SIGNATURE"];
+// $event = null;
+
+// if (getDolGlobalString('STRIPE_DEBUG')) {
+// 	$fh = fopen(DOL_DATA_ROOT.'/dolibarr_stripeipn_payload.log', 'w+');
+// 	if ($fh) {
+// 		fwrite($fh, dol_print_date(dol_now('gmt'), 'standard').' IPN Called. service='.$service.' HTTP_STRIPE_SIGNATURE='.$sig_header."\n");
+// 		fwrite($fh, $payload);
+// 		fclose($fh);
+// 		dolChmod(DOL_DATA_ROOT.'/dolibarr_stripeipn_payload.log');
+// 	}
+// }
+
+// $error = 0;
+
+// try {
+// 	$event = \Stripe\Webhook::constructEvent($payload, $sig_header, $endpoint_secret);
+// } catch (UnexpectedValueException $e) {
+// 	// Invalid payload
+// 	httponly_accessforbidden('Invalid payload', 400);
+// } catch (\Stripe\Exception\SignatureVerificationException $e) {
+// 	httponly_accessforbidden('Invalid signature. May be a hook for an event created by another Stripe env ? Check setup of your keys whsec_...', 400);
+// } catch (Exception $e) {
+// 	httponly_accessforbidden('Error '.$e->getMessage(), 400);
+// }
+
+$payload = @file_get_contents("php://input");
+$sig_header = empty($_SERVER["HTTP_STRIPE_SIGNATURE"]) ? '' : $_SERVER["HTTP_STRIPE_SIGNATURE"];
+
+// On tente de parser sans signature pour récupérer l'account
+$tmp_event = json_decode($payload);
+$account_from_event = !empty($tmp_event->account) ? $tmp_event->account : null;
+
+if (!$account_from_event) {
+	httponly_accessforbidden("Stripe account ID not found in webhook payload", 400);
+}
+
+// Mapping personnalisé
+$stripeAccounts = array(
+	'RIDIN' => getDolGlobalString('STRIPE_CONNECT_ID_RIDIN'),
+	'FESTI' => getDolGlobalString('STRIPE_CONNECT_ID_FESTI'),
+);
+$env = GETPOSTISSET('test') ? 'TEST' : 'LIVE';
+
+// Trouver le code correspondant à l'account Stripe
+$account_code = null;
+foreach ($stripeAccounts as $code => $stripe_id) {
+	if ($account_from_event === $stripe_id) {
+		$account_code = $code;
+		break;
 	}
 }
 
+if (!$account_code) {
+	httponly_accessforbidden("No matching Stripe account configuration for ID: $account_from_event", 400);
+}
+
+// Charger la bonne clé webhook
+$endpoint_secret = getDolGlobalString("STRIPE_{$env}_WEBHOOK_KEY_{$account_code}");
+$service = ($env === 'TEST') ? 'StripeTest' : 'StripeLive';
+$servicestatus = ($env === 'TEST') ? 0 : 1;
+
 if (!isModEnabled('stripe')) {
 	httponly_accessforbidden('Module Stripe not enabled');
 }
 
 if (empty($endpoint_secret)) {
-	httponly_accessforbidden('Error: Setup of module Stripe not complete for mode '.dol_escape_htmltag($service).'. The WEBHOOK_KEY is not defined.', 400, 1);
+	httponly_accessforbidden("Webhook key not configured for account $account_code in $env environment", 400);
 }
 
+// Charger l'utilisateur
 if (getDolGlobalString('STRIPE_USER_ACCOUNT_FOR_ACTIONS')) {
-	// We set the user to use for all ipn actions in Dolibarr
 	$user = new User($db);
 	$user->fetch(getDolGlobalString('STRIPE_USER_ACCOUNT_FOR_ACTIONS'));
 	$user->loadRights();
 } else {
-	httponly_accessforbidden('Error: Setup of module Stripe not complete for mode '.dol_escape_htmltag($service).'. The STRIPE_USER_ACCOUNT_FOR_ACTIONS is not defined.', 400, 1);
+	httponly_accessforbidden("Missing STRIPE_USER_ACCOUNT_FOR_ACTIONS constant", 400);
 }
 
-$now = dol_now();
-
-// Security
-// The test on security key is done later into constructEvent() method.
-
-
-/*
- * Actions
- */
-
-$payload = @file_get_contents("php://input");
-$sig_header = empty($_SERVER["HTTP_STRIPE_SIGNATURE"]) ? '' : $_SERVER["HTTP_STRIPE_SIGNATURE"];
-$event = null;
-
-if (getDolGlobalString('STRIPE_DEBUG')) {
-	$fh = fopen(DOL_DATA_ROOT.'/dolibarr_stripeipn_payload.log', 'w+');
-	if ($fh) {
-		fwrite($fh, dol_print_date(dol_now('gmt'), 'standard').' IPN Called. service='.$service.' HTTP_STRIPE_SIGNATURE='.$sig_header."\n");
-		fwrite($fh, $payload);
-		fclose($fh);
-		dolChmod(DOL_DATA_ROOT.'/dolibarr_stripeipn_payload.log');
-	}
-}
-
-$error = 0;
-
+// ConstructEvent sécurisé
 try {
 	$event = \Stripe\Webhook::constructEvent($payload, $sig_header, $endpoint_secret);
 } catch (UnexpectedValueException $e) {
-	// Invalid payload
 	httponly_accessforbidden('Invalid payload', 400);
 } catch (\Stripe\Exception\SignatureVerificationException $e) {
-	httponly_accessforbidden('Invalid signature. May be a hook for an event created by another Stripe env ? Check setup of your keys whsec_...', 400);
+	httponly_accessforbidden('Invalid signature for webhook', 400);
 } catch (Exception $e) {
-	httponly_accessforbidden('Error '.$e->getMessage(), 400);
+	httponly_accessforbidden('Error: ' . $e->getMessage(), 400);
 }
 
+
 // Do something with $event
 
 $langs->load("main");
@@ -146,10 +211,10 @@
 
 if (isModEnabled('multicompany') && !empty($conf->stripeconnect->enabled) && is_object($mc)) {
 	$sql = "SELECT entity";
-	$sql .= " FROM ".MAIN_DB_PREFIX."oauth_token";
-	$sql .= " WHERE service = '".$db->escape($service)."' and tokenstring LIKE '%".$db->escape($db->escapeforlike($event->account))."%'";
+	$sql .= " FROM " . MAIN_DB_PREFIX . "oauth_token";
+	$sql .= " WHERE service = '" . $db->escape($service) . "' and tokenstring LIKE '%" . $db->escape($db->escapeforlike($event->account)) . "%'";
 
-	dol_syslog(get_class($db)."::fetch", LOG_DEBUG);
+	dol_syslog(get_class($db) . "::fetch", LOG_DEBUG);
 	$result = $db->query($sql);
 	if ($result) {
 		if ($db->num_rows($result)) {
@@ -175,29 +240,29 @@
 
 top_httphead();
 
-dol_syslog("***** Stripe IPN was called with event->type=".$event->type." service=".$service);
+dol_syslog("***** Stripe IPN was called with event->type=" . $event->type . " service=" . $service);
 
 
 if ($event->type == 'payout.created' && getDolGlobalString('STRIPE_AUTO_RECORD_PAYOUT')) {
 	// When a payout is created by Stripe to transfer money to your account
 	$error = 0;
 
-	$result = dolibarr_set_const($db, $service."_NEXTPAYOUT", date('Y-m-d H:i:s', $event->data->object->arrival_date), 'chaine', 0, '', $conf->entity);
+	$result = dolibarr_set_const($db, $service . "_NEXTPAYOUT", date('Y-m-d H:i:s', $event->data->object->arrival_date), 'chaine', 0, '', $conf->entity);
 
 	if ($result > 0) {
-		$subject = '['.$societeName.'] Notification - Stripe payout scheduled';
+		$subject = '[' . $societeName . '] Notification - Stripe payout scheduled';
 		if (!empty($user->email)) {
-			$sendto = dolGetFirstLastname($user->firstname, $user->lastname)." <".$user->email.">";
+			$sendto = dolGetFirstLastname($user->firstname, $user->lastname) . " <" . $user->email . ">";
 		} else {
-			$sendto = getDolGlobalString('MAIN_INFO_SOCIETE_MAIL') . '" <' . getDolGlobalString('MAIN_INFO_SOCIETE_MAIL').'>';
+			$sendto = getDolGlobalString('MAIN_INFO_SOCIETE_MAIL') . '" <' . getDolGlobalString('MAIN_INFO_SOCIETE_MAIL') . '>';
 		}
 		$replyto = $sendto;
 		$sendtocc = '';
 		if (getDolGlobalString('ONLINE_PAYMENT_SENDEMAIL')) {
-			$sendtocc = getDolGlobalString('ONLINE_PAYMENT_SENDEMAIL') . '" <' . getDolGlobalString('ONLINE_PAYMENT_SENDEMAIL').'>';
+			$sendtocc = getDolGlobalString('ONLINE_PAYMENT_SENDEMAIL') . '" <' . getDolGlobalString('ONLINE_PAYMENT_SENDEMAIL') . '>';
 		}
 
-		$message = "A bank transfer of ".price2num($event->data->object->amount / 100)." ".$event->data->object->currency." should arrive in your account the ".dol_print_date($event->data->object->arrival_date, 'dayhour');
+		$message = "A bank transfer of " . price2num($event->data->object->amount / 100) . " " . $event->data->object->currency . " should arrive in your account the " . dol_print_date($event->data->object->arrival_date, 'dayhour');
 
 		$mailfile = new CMailFile(
 			$subject,
@@ -224,7 +289,7 @@
 } elseif ($event->type == 'payout.paid' && getDolGlobalString('STRIPE_AUTO_RECORD_PAYOUT')) {
 	// When a payout to transfer money to your account is completely done
 	$error = 0;
-	$result = dolibarr_set_const($db, $service."_NEXTPAYOUT", 0, 'chaine', 0, '', $conf->entity);
+	$result = dolibarr_set_const($db, $service . "_NEXTPAYOUT", 0, 'chaine', 0, '', $conf->entity);
 	if ($result) {
 		$langs->load("errors");
 
@@ -232,7 +297,7 @@
 		$label = $event->data->object->description;
 		$amount = $event->data->object->amount / 100;
 		$amount_to = $event->data->object->amount / 100;
-		require_once DOL_DOCUMENT_ROOT.'/compta/bank/class/account.class.php';
+		require_once DOL_DOCUMENT_ROOT . '/compta/bank/class/account.class.php';
 
 		$accountfrom = new Account($db);
 		$accountfrom->fetch(getDolGlobalInt('STRIPE_BANK_ACCOUNT_FOR_PAYMENTS'));
@@ -265,13 +330,13 @@
 			}
 
 			if (!$error) {
-				$result = $accountfrom->add_url_line($bank_line_id_from, $bank_line_id_to, DOL_URL_ROOT.'/compta/bank/line.php?rowid=', '(banktransfert)', 'banktransfert');
+				$result = $accountfrom->add_url_line($bank_line_id_from, $bank_line_id_to, DOL_URL_ROOT . '/compta/bank/line.php?rowid=', '(banktransfert)', 'banktransfert');
 			}
 			if (!($result > 0)) {
 				$error++;
 			}
 			if (!$error) {
-				$result = $accountto->add_url_line($bank_line_id_to, $bank_line_id_from, DOL_URL_ROOT.'/compta/bank/line.php?rowid=', '(banktransfert)', 'banktransfert');
+				$result = $accountto->add_url_line($bank_line_id_to, $bank_line_id_from, DOL_URL_ROOT . '/compta/bank/line.php?rowid=', '(banktransfert)', 'banktransfert');
 			}
 			if (!($result > 0)) {
 				$error++;
@@ -285,19 +350,19 @@
 
 			// Send email
 			if (!$error) {
-				$subject = '['.$societeName.'] - NotificationOTIFICATION] Stripe payout done';
+				$subject = '[' . $societeName . '] - NotificationOTIFICATION] Stripe payout done';
 				if (!empty($user->email)) {
-					$sendto = dolGetFirstLastname($user->firstname, $user->lastname)." <".$user->email.">";
+					$sendto = dolGetFirstLastname($user->firstname, $user->lastname) . " <" . $user->email . ">";
 				} else {
-					$sendto = getDolGlobalString('MAIN_INFO_SOCIETE_MAIL') . '" <' . getDolGlobalString('MAIN_INFO_SOCIETE_MAIL').'>';
+					$sendto = getDolGlobalString('MAIN_INFO_SOCIETE_MAIL') . '" <' . getDolGlobalString('MAIN_INFO_SOCIETE_MAIL') . '>';
 				}
 				$replyto = $sendto;
 				$sendtocc = '';
 				if (getDolGlobalString('ONLINE_PAYMENT_SENDEMAIL')) {
-					$sendtocc = getDolGlobalString('ONLINE_PAYMENT_SENDEMAIL') . '" <' . getDolGlobalString('ONLINE_PAYMENT_SENDEMAIL').'>';
+					$sendtocc = getDolGlobalString('ONLINE_PAYMENT_SENDEMAIL') . '" <' . getDolGlobalString('ONLINE_PAYMENT_SENDEMAIL') . '>';
 				}
 
-				$message = "A bank transfer of ".price2num($event->data->object->amount / 100)." ".$event->data->object->currency." has been done to your account the ".dol_print_date($event->data->object->arrival_date, 'dayhour');
+				$message = "A bank transfer of " . price2num($event->data->object->amount / 100) . " " . $event->data->object->currency . " has been done to your account the " . dol_print_date($event->data->object->arrival_date, 'dayhour');
 
 				$mailfile = new CMailFile(
 					$subject,
@@ -332,7 +397,7 @@
 } elseif ($event->type == 'customer.deleted') {
 	// When a customer account is delete on Stripe side
 	$db->begin();
-	$sql = "DELETE FROM ".MAIN_DB_PREFIX."societe_account WHERE key_account = '".$db->escape($event->data->object->id)."' AND site = 'stripe'";
+	$sql = "DELETE FROM " . MAIN_DB_PREFIX . "societe_account WHERE key_account = '" . $db->escape($event->data->object->id) . "' AND site = 'stripe'";
 	$db->query($sql);
 	$db->commit();
 } elseif ($event->type == 'payment_intent.succeeded') {
@@ -355,12 +420,12 @@
 	$payment_amount = 0;
 	$payment_amountInDolibarr = 0;
 
-	dol_syslog("Try to find a payment in database for the payment_intent id = ".$TRANSACTIONID);
+	dol_syslog("Try to find a payment in database for the payment_intent id = " . $TRANSACTIONID);
 
 	$sql = "SELECT pi.rowid, pi.fk_facture, pi.fk_prelevement_bons, pi.amount, pi.type, pi.traite";
-	$sql .= " FROM ".MAIN_DB_PREFIX."prelevement_demande as pi";
-	$sql .= " WHERE pi.ext_payment_id = '".$db->escape($TRANSACTIONID)."'";
-	$sql .= " AND pi.ext_payment_site = '".$db->escape($service)."'";
+	$sql .= " FROM " . MAIN_DB_PREFIX . "prelevement_demande as pi";
+	$sql .= " WHERE pi.ext_payment_id = '" . $db->escape($TRANSACTIONID) . "'";
+	$sql .= " AND pi.ext_payment_site = '" . $db->escape($service) . "'";
 
 	$result = $db->query($sql);
 	if ($result) {
@@ -376,9 +441,9 @@
 					$payment_amountInDolibarr = $obj->amount;
 					$paymentTypeCodeInDolibarr = $obj->type;
 
-					dol_syslog("Found a request in database to pay with direct debit generated (pdid = ".$pdid." directdebitorcreditransfer_id=".$directdebitorcreditransfer_id.")");
+					dol_syslog("Found a request in database to pay with direct debit generated (pdid = " . $pdid . " directdebitorcreditransfer_id=" . $directdebitorcreditransfer_id . ")");
 				} else {
-					dol_syslog("Found a request in database not yet generated (pdid = ".$pdid." directdebitorcreditransfer_id=".$directdebitorcreditransfer_id."). Was the order deleted after being sent ?", LOG_WARNING);
+					dol_syslog("Found a request in database not yet generated (pdid = " . $pdid . " directdebitorcreditransfer_id=" . $directdebitorcreditransfer_id . "). Was the order deleted after being sent ?", LOG_WARNING);
 				}
 			}
 			if ($obj->type == 'card' || empty($obj->type)) {
@@ -389,15 +454,15 @@
 					$payment_amountInDolibarr = $obj->amount;
 					$paymentTypeCodeInDolibarr = empty($obj->type) ? 'card' : $obj->type;
 
-					dol_syslog("Found a request in database to pay with card (pdid = ".$pdid."). We should fix status traite to 1");
+					dol_syslog("Found a request in database to pay with card (pdid = " . $pdid . "). We should fix status traite to 1");
 				} else {
-					dol_syslog("Found a request in database to pay with card (pdid = ".$pdid.") already set to traite=1. Nothing to fix.");
+					dol_syslog("Found a request in database to pay with card (pdid = " . $pdid . ") already set to traite=1. Nothing to fix.");
 				}
 			}
 		} else {
-			dol_syslog("Payment intent ".$TRANSACTIONID." not found into database, so ignored.");
+			dol_syslog("Payment intent " . $TRANSACTIONID . " not found into database, so ignored.");
 			http_response_code(200);
-			print "Payment intent ".$TRANSACTIONID." not found into database, so ignored.";
+			print "Payment intent " . $TRANSACTIONID . " not found into database, so ignored.";
 			return 1;
 		}
 	} else {
@@ -411,7 +476,7 @@
 
 		$stripeacc = $stripearrayofkeysbyenv[$servicestatus]['secret_key'];
 
-		dol_syslog("Get the Stripe payment object for the payment method id = ".json_encode($paymentmethodstripeid));
+		dol_syslog("Get the Stripe payment object for the payment method id = " . json_encode($paymentmethodstripeid));
 
 		$s = new \Stripe\StripeClient($stripeacc);
 
@@ -446,7 +511,7 @@
 			} else {
 				$paiement->multicurrency_amounts = [$invoice_id => $payment_amount];   // Array with all payments dispatching
 
-				$postactionmessages[] = 'Payment was done in a currency ('.$currencyCodeType.') other than the expected currency of company ('.$conf->currency.')';
+				$postactionmessages[] = 'Payment was done in a currency (' . $currencyCodeType . ') other than the expected currency of company (' . $conf->currency . ')';
 				$ispostactionok = -1;
 				// Not yet supported, so error
 				$error++;
@@ -454,9 +519,9 @@
 
 			// Get ID of payment PRE
 			$paiement->paiementcode = $paymentTypeCode;
-			$sql = "SELECT id FROM ".MAIN_DB_PREFIX."c_paiement";
-			$sql .= " WHERE code = '".$db->escape($paymentTypeCode)."'";
-			$sql .= " AND entity IN (".getEntity('c_paiement').")";
+			$sql = "SELECT id FROM " . MAIN_DB_PREFIX . "c_paiement";
+			$sql .= " WHERE code = '" . $db->escape($paymentTypeCode) . "'";
+			$sql .= " AND entity IN (" . getEntity('c_paiement') . ")";
 			$resql = $db->query($sql);
 			if ($resql) {
 				$obj = $db->fetch_object($resql);
@@ -468,18 +533,18 @@
 			$paiement->num_payment = '';
 			$paiement->note_public = '';
 			$paiement->note_private = 'StripeSepa payment received by IPN webhook - ' . dol_print_date($now, 'standard') . ' (TZ server) using servicestatus=' . $servicestatus . ($ipaddress ? ' from ip ' . $ipaddress : '') . ' - Transaction ID = ' . $TRANSACTIONID;
-			$paiement->ext_payment_id = $TRANSACTIONID.':'.$customer_id.'@'.$stripearrayofkeysbyenv[$servicestatus]['publishable_key'];		// May be we should store py_... instead of pi_... but we started with pi_... so we continue.
+			$paiement->ext_payment_id = $TRANSACTIONID . ':' . $customer_id . '@' . $stripearrayofkeysbyenv[$servicestatus]['publishable_key'];		// May be we should store py_... instead of pi_... but we started with pi_... so we continue.
 			$paiement->ext_payment_site = $service;
 
 			$ispaymentdone = 0;
-			$sql = "SELECT p.rowid FROM ".MAIN_DB_PREFIX."paiement as p";
-			$sql .= " WHERE p.ext_payment_id = '".$db->escape($paiement->ext_payment_id)."'";
-			$sql .= " AND p.ext_payment_site = '".$db->escape($paiement->ext_payment_site)."'";
+			$sql = "SELECT p.rowid FROM " . MAIN_DB_PREFIX . "paiement as p";
+			$sql .= " WHERE p.ext_payment_id = '" . $db->escape($paiement->ext_payment_id) . "'";
+			$sql .= " AND p.ext_payment_site = '" . $db->escape($paiement->ext_payment_site) . "'";
 			$result = $db->query($sql);
 			if ($result) {
 				if ($db->num_rows($result)) {
 					$ispaymentdone = 1;
-					dol_syslog('* Payment for ext_payment_id '.$paiement->ext_payment_id.' already done. We do not recreate the payment');
+					dol_syslog('* Payment for ext_payment_id ' . $paiement->ext_payment_id . ' already done. We do not recreate the payment');
 				}
 			}
 
@@ -506,16 +571,16 @@
 			if (!$error && isModEnabled('bank')) {
 				// Search again the payment to see if it is already linked to a bank payment record (We should always find the payment that was created before).
 				$ispaymentdone = 0;
-				$sql = "SELECT p.rowid, p.fk_bank FROM ".MAIN_DB_PREFIX."paiement as p";
-				$sql .= " WHERE p.ext_payment_id = '".$db->escape($paiement->ext_payment_id)."'";
-				$sql .= " AND p.ext_payment_site = '".$db->escape($paiement->ext_payment_site)."'";
+				$sql = "SELECT p.rowid, p.fk_bank FROM " . MAIN_DB_PREFIX . "paiement as p";
+				$sql .= " WHERE p.ext_payment_id = '" . $db->escape($paiement->ext_payment_id) . "'";
+				$sql .= " AND p.ext_payment_site = '" . $db->escape($paiement->ext_payment_site) . "'";
 				$sql .= " AND p.fk_bank <> 0";
 				$result = $db->query($sql);
 				if ($result) {
 					if ($db->num_rows($result)) {
 						$ispaymentdone = 1;
 						$obj = $db->fetch_object($result);
-						dol_syslog('* Payment already linked to bank record '.$obj->fk_bank.' . We do not recreate the link');
+						dol_syslog('* Payment already linked to bank record ' . $obj->fk_bank . ' . We do not recreate the link');
 					}
 				}
 				if (!$ispaymentdone) {
@@ -547,14 +612,14 @@
 				$bon = new BonPrelevement($db);
 				$idbon = 0;
 				$sql = "SELECT dp.fk_prelevement_bons as idbon";
-				$sql .= " FROM ".MAIN_DB_PREFIX."prelevement_demande as dp";
-				$sql .= " JOIN ".MAIN_DB_PREFIX."prelevement_bons as pb"; // Here we join to prevent modification of a prelevement bon already credited
+				$sql .= " FROM " . MAIN_DB_PREFIX . "prelevement_demande as dp";
+				$sql .= " JOIN " . MAIN_DB_PREFIX . "prelevement_bons as pb"; // Here we join to prevent modification of a prelevement bon already credited
 				$sql .= " ON pb.rowid = dp.fk_prelevement_bons";
-				$sql .= " WHERE dp.fk_facture = ".((int) $invoice_id);
+				$sql .= " WHERE dp.fk_facture = " . ((int) $invoice_id);
 				$sql .= " AND dp.sourcetype = 'facture'";
-				$sql .= " AND dp.ext_payment_id = '".$db->escape($TRANSACTIONID)."'";
+				$sql .= " AND dp.ext_payment_id = '" . $db->escape($TRANSACTIONID) . "'";
 				$sql .= " AND dp.traite = 1";
-				$sql .= " AND statut = ".((int) $bon::STATUS_TRANSFERED); // To be sure that it's not already credited
+				$sql .= " AND statut = " . ((int) $bon::STATUS_TRANSFERED); // To be sure that it's not already credited
 				$result = $db->query($sql);
 				if ($result) {
 					if ($db->num_rows($result)) {
@@ -571,13 +636,13 @@
 				}
 
 				if (!$error && !empty($idbon)) {
-					$sql = "UPDATE ".MAIN_DB_PREFIX."prelevement_bons";
-					$sql .= " SET fk_user_credit = ".((int) $user->id);
-					$sql .= ", statut = ".((int) $bon::STATUS_CREDITED);
-					$sql .= ", date_credit = '".$db->idate($now)."'";
+					$sql = "UPDATE " . MAIN_DB_PREFIX . "prelevement_bons";
+					$sql .= " SET fk_user_credit = " . ((int) $user->id);
+					$sql .= ", statut = " . ((int) $bon::STATUS_CREDITED);
+					$sql .= ", date_credit = '" . $db->idate($now) . "'";
 					$sql .= ", credite = 1";
-					$sql .= " WHERE rowid = ".((int) $idbon);
-					$sql .= " AND statut = ".((int) $bon::STATUS_TRANSFERED);
+					$sql .= " WHERE rowid = " . ((int) $idbon);
+					$sql .= " AND statut = " . ((int) $bon::STATUS_TRANSFERED);
 
 					$result = $db->query($sql);
 					if (!$result) {
@@ -588,9 +653,9 @@
 				}
 
 				if (!$error && !empty($idbon)) {
-					$sql = "UPDATE ".MAIN_DB_PREFIX."prelevement_lignes";
+					$sql = "UPDATE " . MAIN_DB_PREFIX . "prelevement_lignes";
 					$sql .= " SET statut = 2";
-					$sql .= " WHERE fk_prelevement_bons = ".((int) $idbon);
+					$sql .= " WHERE fk_prelevement_bons = " . ((int) $idbon);
 					$result = $db->query($sql);
 					if (!$result) {
 						$postactionmessages[] = $db->lasterror();
@@ -610,7 +675,7 @@
 				return -1;
 			}
 		} else {
-			dol_syslog("The payment mode of this payment is ".$paymentTypeCode." in Stripe and ".$paymentTypeCodeInDolibarr." in Dolibarr. This case is not managed by the IPN");
+			dol_syslog("The payment mode of this payment is " . $paymentTypeCode . " in Stripe and " . $paymentTypeCodeInDolibarr . " in Dolibarr. This case is not managed by the IPN");
 		}
 	} else {
 		dol_syslog("Nothing to do in database because we don't know paymentTypeIdInDolibarr");
@@ -662,17 +727,17 @@
 		$objpaymentmodetype = $object->last_payment_error->payment_method->type;
 	}
 
-	dol_syslog("objpayid=".$objpayid." objpaymentmodetype=".$objpaymentmodetype." objerrcode=".$objerrcode);
+	dol_syslog("objpayid=" . $objpayid . " objpaymentmodetype=" . $objpaymentmodetype . " objerrcode=" . $objerrcode);
 
 	// If this is a differed payment for SEPA, add a line into agenda events
 	if ($objpaymentmodetype == 'sepa_debit') {
 		$db->begin();
 
-		require_once DOL_DOCUMENT_ROOT.'/comm/action/class/actioncomm.class.php';
+		require_once DOL_DOCUMENT_ROOT . '/comm/action/class/actioncomm.class.php';
 		$actioncomm = new ActionComm($db);
 
 		if ($objinvoiceid > 0) {
-			require_once DOL_DOCUMENT_ROOT.'/compta/facture/class/facture.class.php';
+			require_once DOL_DOCUMENT_ROOT . '/compta/facture/class/facture.class.php';
 			$invoice = new Facture($db);
 			$invoice->fetch($objinvoiceid);
 
@@ -692,7 +757,7 @@
 			$actioncomm->ip = getUserRemoteIP();
 		}
 
-		$actioncomm->note_private = 'Error returned on payment id '.$objpayid.' after SEPA payment request '.$objpaydesc.'<br>Error code is: '.$objerrcode.'<br>Error message is: '.$objerrmessage;
+		$actioncomm->note_private = 'Error returned on payment id ' . $objpayid . ' after SEPA payment request ' . $objpaydesc . '<br>Error code is: ' . $objerrcode . '<br>Error message is: ' . $objerrmessage;
 		$actioncomm->label = 'Payment error (SEPA Stripe)';
 
 		$result = $actioncomm->create($user);
@@ -713,8 +778,8 @@
 	// TODO: create fees
 } elseif ($event->type == 'payment_method.attached') {
 	// When we link a payment method with a customer on Stripe side
-	require_once DOL_DOCUMENT_ROOT.'/societe/class/companypaymentmode.class.php';
-	require_once DOL_DOCUMENT_ROOT.'/societe/class/societeaccount.class.php';
+	require_once DOL_DOCUMENT_ROOT . '/societe/class/companypaymentmode.class.php';
+	require_once DOL_DOCUMENT_ROOT . '/societe/class/societeaccount.class.php';
 	$societeaccount = new SocieteAccount($db);
 
 	$companypaymentmode = new CompanyPaymentMode($db);
@@ -762,9 +827,9 @@
 	}
 } elseif ($event->type == 'payment_method.updated') {
 	// When we update a payment method on Stripe side
-	require_once DOL_DOCUMENT_ROOT.'/societe/class/companypaymentmode.class.php';
+	require_once DOL_DOCUMENT_ROOT . '/societe/class/companypaymentmode.class.php';
 	$companypaymentmode = new CompanyPaymentMode($db);
-	$companypaymentmode->fetch(0, '', 0, '', " AND stripe_card_ref = '".$db->escape($event->data->object->id)."'");
+	$companypaymentmode->fetch(0, '', 0, '', " AND stripe_card_ref = '" . $db->escape($event->data->object->id) . "'");
 	if ($companypaymentmode->id > 0) {
 		// If we found a payment mode with the ID
 		$companypaymentmode->bank            = null;
@@ -797,7 +862,7 @@
 } elseif ($event->type == 'payment_method.detached') {
 	// When we remove a payment method on Stripe side
 	$db->begin();
-	$sql = "DELETE FROM ".MAIN_DB_PREFIX."societe_rib WHERE number = '".$db->escape($event->data->object->id)."' and status = ".((int) $servicestatus);
+	$sql = "DELETE FROM " . MAIN_DB_PREFIX . "societe_rib WHERE number = '" . $db->escape($event->data->object->id) . "' and status = " . ((int) $servicestatus);
 	$db->query($sql);
 	$db->commit();
 } elseif ($event->type == 'charge.succeeded') {
@@ -808,10 +873,10 @@
 	// Deprecated.
 } elseif ($event->type == 'charge.dispute.closed') {
 	// When a dispute to cancel a SEPA payment is finished
-	dol_syslog("object = ".var_export($event->data, true));
+	dol_syslog("object = " . var_export($event->data, true));
 } elseif ($event->type == 'charge.dispute.funds_withdrawn') {
 	// When a dispute/withdraw to cancel a SEPA payment is done
-	dol_syslog("object = ".var_export($event->data, true));
+	dol_syslog("object = " . var_export($event->data, true));
 
 	global $stripearrayofkeysbyenv;
 	$error = 0;
@@ -833,12 +898,12 @@
 	$payment_amount = 0;
 	$payment_amountInDolibarr = 0;
 
-	dol_syslog("Try to find the payment in database for the payment_intent id = ".$TRANSACTIONID);
+	dol_syslog("Try to find the payment in database for the payment_intent id = " . $TRANSACTIONID);
 
 	$sql = "SELECT pi.rowid, pi.fk_facture, pi.fk_prelevement_bons, pi.amount, pi.type, pi.traite";
-	$sql .= " FROM ".MAIN_DB_PREFIX."prelevement_demande as pi";
-	$sql .= " WHERE pi.ext_payment_id = '".$db->escape($TRANSACTIONID)."'";
-	$sql .= " AND pi.ext_payment_site = '".$db->escape($service)."'";
+	$sql .= " FROM " . MAIN_DB_PREFIX . "prelevement_demande as pi";
+	$sql .= " WHERE pi.ext_payment_id = '" . $db->escape($TRANSACTIONID) . "'";
+	$sql .= " AND pi.ext_payment_site = '" . $db->escape($service) . "'";
 
 	$result = $db->query($sql);
 	if ($result) {
@@ -852,7 +917,7 @@
 				$payment_amountInDolibarr = $obj->amount;
 				$paymentTypeCodeInDolibarr = $obj->type;
 
-				dol_syslog("Found the payment intent for ban in database (pdid = ".$pdid." directdebitorcreditransfer_id=".$directdebitorcreditransfer_id.")");
+				dol_syslog("Found the payment intent for ban in database (pdid = " . $pdid . " directdebitorcreditransfer_id=" . $directdebitorcreditransfer_id . ")");
 			}
 			if ($obj->type == 'card' || empty($obj->type)) {
 				// This is a card payment.
